angular.module('sdbgui')
    .component('setadmin', {
        templateUrl: '/static/components/sdbgui-setadmin/sdbgui-setadmin.template.html',
        controller: ['slashDB', function (slashdb) {
            var ctrl = this;
            ctrl.step = 0;
            ctrl.showModal = true;
            ctrl.alert = '';

            ctrl.adminCredentials = {
                user: 'admin',
                password1: '',
                password2: ''
            };

            this.setAdminPassword = function () {
                ctrl.formCtrl.password1.$setTouched();
                ctrl.formCtrl.password2.$setTouched();
                ctrl.alert = '';
                var stepValid = ctrl.formCtrl.password1.$valid && ctrl.formCtrl.password2.$valid;
                if (stepValid) {
                    slashdb.post('/set-admin-password', ctrl.adminCredentials)
                        .then(function (response) {
                            slashdb.login(ctrl.adminCredentials.user, ctrl.adminCredentials.password1);
                            ctrl.step = 1;
                        })
                        .catch(function (response) {
                            ctrl.alert = response.headers('Warning');
                        });
                }
            };
        }]
    });