angular.module('sdbgui', ['ngAnimate', 'ui.bootstrap', 'angularSlashDB', 'ngclipboard', 'ui.codemirror', 'selectize'])
    .config(['$locationProvider', '$compileProvider', '$httpProvider', 'slashDBProvider', 'sessionControlProvider',
    function config($locationProvider, $compileProvider, $httpProvider, slashDBProvider, sessionControlProvider) {
//        $locationProvider.html5Mode({enabled: true, requireBase: false});
//        $locationProvider.hashPrefix('!');

        $compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|ftp|mailto|file|blob):/);

        $httpProvider.defaults.withCredentials = true;

        $httpProvider.interceptors.push(sessionControlProvider.interceptor)

        slashDBProvider.setEndpoint(window.location.origin);
        slashDBProvider.setCacheData(false);
    }]);
