angular
.module(
    'sdbgui',
    [
        'ngMessages', 'ngAnimate', 'ui.bootstrap', 'angularSlashDB',
        'ngclipboard', 'ui.codemirror', 'ui.layout', 'selectize',
    ]
)
.config(['$locationProvider', '$compileProvider', '$httpProvider', 'slashDBProvider', 'sessionControlProvider',
    function config($locationProvider, $compileProvider, $httpProvider, slashDBProvider, sessionControlProvider) {

        $compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|ftp|mailto|file|blob):/);

        $httpProvider.defaults.withCredentials = true;

        $httpProvider.interceptors.push(sessionControlProvider.interceptor)

        slashDBProvider.setEndpoint(window.location.origin);
        slashDBProvider.setCacheData(false);
    }]);